# How to configure MailScanner to log to a remote MySQL database

This document presumes that you will have a server acting as a database with PHP and MySQL installed on it, and multiple MailScanner gateways logging to the database server.

1)  Follow steps 1 to 6 from the INSTALL document on the database server.

2)  Create a mailscanner user and password on the database server:  
    % mysql mailscanner  
    mysql>  GRANT ALL ON mailscanner.* TO mailscanner IDENTIFIED BY 'password';  
    mysql> flush privileges;

3)  On each MailScanner gateway, you'll need to make sure that the mysql client, perl, perl DBI and perl DBD-Mysql, are installed:  
    % rpm -qa | grep "mysql"  
    mysql-3.23.54a-11  
    % rpm -qa | grep "perl-DB"  
    perl-DBD-MySQL-2.1021-3  
    perl-DBI-1.32-5  

4)  From one of the MailScanner gateway, verify you can connect to the db:  
    % mysql mailscanner -u mailscanner -h <db_hostname> -p  
    Enter password: *******  
    If you get a mysql> prompt, you can connect correctly (enter \q to quit).

5)  On each MailScanner gateway, do steps 7 to 10 from the INSTALL document, for step 7, you will also need to edit CustomConfig.pm and change the $db_host, $db_user and $db_pass variables to your local settings.

6)  To complete the set-up run steps 11 to 15 on the database server.

7)  On each MailWatch system set RPC_ALLOWED_CLIENTS in conf.php to a list of IP addresses of each MailWatch system.
